import BusX
import CordX
import SwiftUI

extension MeetupId {
  public struct V: View {
    let fmt = MeetupId.Debounce(5, formatId, K.textUI, K.textApp)
    @StateObject var isJoinAvailable = Cord.Receive(K.isJoinAvailable, false)
    @StateObject var isLoading = Cord.Receive(K.isLoading, false)
    @StateObject var join = Cord.Button(K.join)
    @StateObject var textField = Cord.TextField(K.textApp, K.textUI)
    let procs: [Any] = [
      Bus.Processor(shouldEnableJoin, K.M, K.isJoinAvailable),
    ]  
    
    public init() { }
    
    public var body: some View {
      VStack(spacing: 8) {
        HStack {
          TextField("Binding-3", value: $textField.v, formatter: Cord.TextFieldValueOwner())
            .disabled(isLoading.v)
            .padding(8)
            .border(
              !isLoading.v ? Color.black : Color.gray,
              width: !isLoading.v ? 2 : 1
            )
          if isLoading.v {
            ProgressView()
              .padding(8)
          }
        }

        Button(action: join.v.send) {
          Text("Join")
            .padding(8)
            .border(
              isJoinAvailable.v ? Color.green : Color.gray,
              width: isJoinAvailable.v ? 2 : 1
            )
        }
        .disabled(!isJoinAvailable.v)
      }
      .frame(width: 320)
      .padding()
      .animation(.easeInOut(duration: 0.3))
    }
  }
}
